/*
 * MosP - Mind Open Source Project         http://www.mosp.jp/
 * Copyright (C) 1987-2008 MIND Co., Ltd.  http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.kintai.action;

import java.util.Date;

import jp.mosp.common.CommonConst;
import jp.mosp.common.common.MospConst;
import jp.mosp.common.common.MospException;
import jp.mosp.common.common.MospUtility;

import jp.mosp.kintai.dto.MSyukkinboDto;
import jp.mosp.kintai.vo.AttendanceHolidayCardVo;

public class AttendanceHolidayCardAction extends AttendanceTotalAction {

	// コマンド
	public static final String CMD_HOLIDAY_CARD_SHOW		= "K1130";
	public static final String CMD_HOLIDAY_CARD_SELECT	= "K1131";
	private static final String CMD_HOLIDAY_CARD_REGIST	= "K1132";
	private static final String CMD_HOLIDAY_CARD_DELETE	= "K1133";

	/**
	 * コンストラクタ
	 */
	public AttendanceHolidayCardAction() {
		super();
	}

	public void action() throws Exception {
		// VOの取得
		AttendanceHolidayCardVo vo;
		vo = (AttendanceHolidayCardVo)getStoredVo(CommonConst.VO_ATTENDANCE_HOLIDAY_CARD);
		if (vo == null) {
			vo = new AttendanceHolidayCardVo();
		}
		vo.initVo(cfg, msg, cmd, aspUser, user);
		vo.clearMessage();
		vo.clearErrField();
		storeVo(CommonConst.VO_ATTENDANCE_HOLIDAY_CARD, vo);
		// VO及びフォワード先URLの設定
		setVo(vo);
		setUrl(vo.getRetUrl());
		// DTOの取得
		MSyukkinboDto dto;
		Object objDto = session.getAttribute(MospConst.ATT_DTO);
		dto = objDto instanceof MSyukkinboDto ? (MSyukkinboDto)objDto : null;
		// DBコネクション取得
		getConnection();
		// ユーザー情報取得
		getInfo(user.getUserId());
		// 充当日年プルダウン
		vo.aryPltSubstituteYear = util.getYearArray(MospUtility.getYear (util.getSystemDate()), 1, 2);
		// 充当日月プルダウン
		vo.aryPltSubstituteMonth = util.getMonthArray();
		// 充当日日プルダウン
		vo.aryPltSubstituteDay = util.getDayArray();
		// 休暇理由プルダウン
		vo.aryPltHolidayReason = getReasonCodeArray(CommonConst.TID_LEAVE_REASON);
		// 休暇証明書プルダウン
		vo.aryPltHolidayCertificate = getMosPCodeArray(CommonConst.TID_HOLIDAY_CERTIFICATE);
		// 勤怠管理コマンド
		setSubTitleMenu(vo);
		// コマンド毎の処理
		if (cmd.equals(CMD_HOLIDAY_CARD_SHOW)) {
			// 表示項目の初期化
			vo.initFields();
			// 表示の準備
			setAttendanceInfo(vo);
			// 表示ボタンは出勤
			// 出勤ボタンにコマンドをセット
			vo.setCmdStartButton(AttendanceStartCardAction.CMD_START_CARD_SHOW);
			// 表示モードセット
			setMode(vo, dto);
		} else if (cmd.equals(CMD_HOLIDAY_CARD_SELECT)) {
			// 表示の準備
			setAttendanceInfo(vo);
			// 休暇検索
			dto = searchHoliday(vo);
			// 休暇ボタンにコマンドをセット
			vo.setCmdHolidayButton(CMD_HOLIDAY_CARD_SELECT);		
			// セッションにDTOをセット
			session.setAttribute(MospConst.ATT_DTO, dto);
		} else if (cmd.equals(CMD_HOLIDAY_CARD_REGIST)) {
			vo.setParams(request);
			// 登録
			dto = registHoliday(vo, dto);
			// セッションにDTOをセット
			session.setAttribute(MospConst.ATT_DTO, dto);
			// 勤怠一覧へ遷移
			setNextCmd(AttendanceListAction.CMD_ATTENDANCE_LIST_RE_SEARCH);
			// メッセージ設定
			request.setAttribute(MospConst.ATT_MESSAGE, MospUtility.getMessage(msg, MospConst.MSG_UPDATE, ""));
		} else if (cmd.equals(CMD_HOLIDAY_CARD_DELETE)) {
			vo.setParams(request);
			// 削除
			dto = delete(vo, dto);
			// セッションにDTOをセット
			session.setAttribute(MospConst.ATT_DTO, dto);
			// 勤怠一覧へ遷移
			setNextCmd(AttendanceListAction.CMD_ATTENDANCE_LIST_RE_SEARCH);
			// メッセージ設定
			request.setAttribute(MospConst.ATT_MESSAGE, MospUtility.getMessage(msg, MospConst.MSG_DELETE, ""));			
		} else {
			throw new MospException(MospConst.EX_CMD_INVALID);
		}
		// 再検索用MenuVoの保存
		setStoreAttendanceMenuVo(vo);
	}

	/**
	 * 休暇検索
	 * @param vo AttendanceCardVoインスタンス
	 * @return 取得AttendanceCardDtoインスタンス
	 * @throws Exception
	 */
	private MSyukkinboDto searchHoliday(AttendanceHolidayCardVo vo) throws Exception {
		// 勤怠検索
		MSyukkinboDto dto = getSyukkinboInfo(vo.getHidKCode(), vo.getHidDate());
		// VOに情報を設定
		vo.setFields(dto);
		// 表示モードのセット
		setMode(vo, dto);
		return dto;
	}

	/**
	 * 休暇登録
	 * @param vo  Voインスタンス
	 * @param dto Dtoインスタンス
	 * @return 登録後再取得Dtoインスタンス
	 * @throws Exception
	 */
	private MSyukkinboDto registHoliday(
			AttendanceHolidayCardVo vo,
			MSyukkinboDto dto
	) throws Exception {
		// パラメータの妥当性確認
		vo.validate();
		// DBコネクションの取得
		if (conn == null) {
			getConnection();
		}
		// 出勤簿用DAO準備 
		prepareMSyukkinboDao();
		// 勤怠検索
		MSyukkinboDto mSyukkinboDto = new MSyukkinboDto();
		if (dto == null) {
			// INSERT(セッション保存DTOが存在しない場合)
			// 自動計算
			runAutoHolidayCalc(vo);
			vo.setDtoFields(mSyukkinboDto);
			mSyukkinboDto.setSyozoku(mKihon.getSCode());
			// 存在チェック
			chkDuplicate(getSyukkinboInfo(mSyukkinboDto.getKCode(), mSyukkinboDto.getHizuke()), vo);
			// 登録（休暇項目のみ）			
			syukkinboDao.insertHoliday(mSyukkinboDto);
		} else {
			// 承認済みの場合はメッセージ表示、登録不可
			if (isApproved(dto)) {
				// メッセージ設定
				request.setAttribute(MospConst.ATT_MESSAGE, 
						MospUtility.getMessage(msg, CommonConst.MSG_ALREADY_APPROVED, 
								getMessageDate(vo.getHidYear(), vo.getHidMonth(), vo.getHidDay())
						)
				);
			} else {
				// UPDATE(セッション保存DTOが存在する場合)
				mSyukkinboDto = dto;
				// 排他確認
				chkExclusive(mSyukkinboDto, getSyukkinboInfo(mSyukkinboDto.getKCode(), mSyukkinboDto.getHizuke(), true), vo);
				// 自動計算
				runAutoHolidayCalc(vo);
				vo.setDtoFields(mSyukkinboDto);
				// 更新（休暇項目のみ）
				syukkinboDao.updateHoliday(mSyukkinboDto);
			}
		}
		// DTOの再取得
		MSyukkinboDto retDto = getSyukkinboInfo(mSyukkinboDto.getKCode(), mSyukkinboDto.getHizuke());
		chkUpdate(retDto);
		// コミット
		commit();
		// メッセージ設定
		vo.setMessage(MospUtility.getMessage(msg, MospConst.MSG_UPDATE, ""));
		return retDto;
	}

	/**
	 * 休暇項目削除
	 * @param dto
	 * @throws Exception
	 */
	private MSyukkinboDto delete(AttendanceHolidayCardVo vo, MSyukkinboDto dto) throws Exception {
		// 出勤簿用DAO準備 
		prepareMSyukkinboDao();
		// データ存在確認
		chkExist(dto);
		// 承認済みの場合はメッセージ表示、削除不可
		if (isApproved(dto)) {
			// メッセージ設定
			request.setAttribute(MospConst.ATT_MESSAGE, 
					MospUtility.getMessage(msg, CommonConst.MSG_ALREADY_APPROVED, 
							getMessageDate(vo.getHidYear(), vo.getHidMonth(), vo.getHidDay()))
			);
		} else {
			// 削除
			syukkinboDao.delete(dto);
		}
		// DTOの再取得
		MSyukkinboDto retDto = getSyukkinboInfo(dto.getKCode(), dto.getHizuke());
		// コミット
		commit();
		return retDto;
	}

	/**
	 * 自動計算メソッド
	 * @param vo
	 * @throws Exception
	 */
	private void runAutoHolidayCalc(AttendanceHolidayCardVo vo) throws Exception {
		// 対象日取得
		Date targetDay = util.convStringDateToDate(vo.getHidDate());
		// 勤怠日データ取得
		getAttendanceDay(vo.getHidKCode(), targetDay);
		// 自動計算フラグ有りのみ
		if (isAutoCalc) {
			// 全休休暇時間
			vo.setHolidayTimes(allHoliday);
		}
	}

}
